#include <linux/module.h>
#include <linux/fs.h>
//#include <linux/sched.h>
#include <linux/moduleparam.h>

static char* file = "/proc/kallsyms";
module_param(file, charp, 0); 
static int debug = 0; 
module_param(debug, int, 0); 

uintptr_t hex2adr(char *b) {
    uintptr_t res = 0;
    char *p = b, *d;
    const char *dig = "0123456789abcdef"; 
    while((d = strchr(dig, *p)) != NULL) {
        res = (res << 4) + (d - dig);
        p++; 
    }
    return res; 
}

/*
int verify_close(unsigned long *a) {
//    extern int sys_close(int fd);
    int cmp;
//    unsigned long ca = *(a + __NR_close);
//    cmp = ((void*)ca == (void*)sys_close) ? 0 : 1;
    return cmp; 
} */

void put_table(char *b) {
    int i;
    char table[120] = "sys_call_table : "; 
    unsigned long *a;
    uintptr_t s = hex2adr(b);    
    printk("+ %s", b);
    printk("+ %lx\n", s);
    printk("+ %px\n", (void*)s);

//    a = (void*)s;
//    printk("+ sys_call_table address = %px\n", b);
//    printk("+ sys_call_table address = %s\n", b);
return;    
//    printk("+ sys_call_table address = %p\n", a);
/*    if(verify_close(a) != 0) {
        printk("+ sys_close address not valid!\n");
        return;
    } */
    for(i = 0; i < 10; i++) {
        unsigned long sa = *(a + i);
        sprintf(table + strlen(table), "%p ", (void*)sa);
    }
    printk("+ %s ...\n", table);
}

#define BUF_LEN 255
static char buff[BUF_LEN + 1];
        
static int __init stread_init(void) {
    struct file *f;
    loff_t pos = 0;
    int err = -EPERM;

    f = filp_open(file, O_RDONLY, 0);
    if(IS_ERR(f)) {
        printk("+ failed to open: %s\n", file);
        err = -ENOENT;
        goto close;
    }
    printk("+ openning file: %s\n", file);
    if(!(f->f_mode & FMODE_READ)) {
        err = -EBADF;
        goto close;
    }
    if(!f->f_op) {
        if(!f->f_op->read)
            printk("+ read op. => %px\n", f->f_op->read);
    }
    else
        printk("+ op. table => %px\n", (void*)0);

//goto close;

    while(1) {
        size_t k;
        char *p = buff, *find = NULL;
        int n;
//        do {
        for(n = 0; n < BUF_LEN; n++) {
           // ssize_t kernel_read(struct file *file, void *buf, size_t count, loff_t *pos);           
            k = kernel_read(f, p++, 1, &pos);
//            k = kernel_read(f, buff + n, 1, NULL);
            if(k < 0) {
                printk("+ failed to read\n");
                err = -EIO;
                goto close;
            }
//            buff[n + k] = '\0';
            *p = '\0';
            if(0 == k) break;           // EOF
//            if('\n' == *(p - 1)) break; // считана строка
//        } while(1);
        }

//        printk("+ %s", buff);
//        goto close;
        
        if((debug != 0) && (strlen(buff) > 0)) {
            if('\n' == buff[strlen(buff) - 1]) printk("+ %s", buff);
            else printk("+ %s|\n", buff);
        }
        if(0 == k) break;   // EOF
        if(NULL == (find = strstr(buff, " sys_call_table\n"))) continue;
//        put_table(buff);
        printk("+ %s", buff);
        break;
    }

close:
    printk("+ close file: %s\n", file);
    filp_close(f, NULL);
    return err;
}

module_init(stread_init);
MODULE_LICENSE("GPL");
MODULE_AUTHOR("Oleg Tsiliuric <olej.tsil@gmail.com>");
MODULE_VERSION("3.2");
